package WebFlow.submitJob;

import WebFlow.*;
import WebFlow.event.*;
import org.omg.CORBA.*;
import java.util.*;
import java.io.*; 

public class submitJobImpl extends WebFlow.BeanContextChildSupport 
                         implements submitJobOperations {

  String msg_ ; 
  org.omg.CORBA.Object peer ;

  private String user="webflow";
  private String thisHost="osprey4.npac.syr.edu";
  private String nextLine;
  private String jobid="0";
  private Hashtable jobTable;

  public submitJobImpl(org.omg.CORBA.Object peer, String msg)
       throws WebFlow.NullPointerException {

  super(peer);
  this.peer = peer;
  String msg_ = msg;
  jobTable = new Hashtable();
 }

  public void test() {
        System.out.println("submitJob is up");
  }


  public void submit(WebFlow.submitJob.CmdLineEvent event) {
    String Host = event.getHost();
    String Rsl = event.getRsl();
    String CmdLine = event.getCmdLine();
    String User = event.getUser();
    User="webflow";

  System.out.println("submit called: "+Host+" "+CmdLine);  

    if(Rsl.startsWith("&")) {
       submitGlobus(Host,Rsl,User);
    }
    else {
      if(Host.indexOf(thisHost)>-1) {
       submitLocally(CmdLine);
      }
      else {
       submitRsh(Host,User,CmdLine);
      }
    } 

  }


  public String submitNQS(String CommandLine) {
   System.out.println("submit NQS: "+CommandLine);
   InputStream is;
   jobThread jt = new jobThread(CommandLine,this);
   Thread runIt = new Thread(jt);
   runIt.start();
   waitForCompletion(1000);
   jobid=jt.getJobId();
   jobTable.put(jobid,Boolean.FALSE);
   System.out.println(jobid); 
   return jobid;    
   }

    public synchronized void waitForCompletion(long howLong) {
    try {
      wait(howLong);
    }
    catch (Exception e) {System.out.println("cannot wait");}
    } 



  public void submitLocally(String CommandLine) {
  System.out.println("submitLocally: "+CommandLine);
   InputStream is; 

   try {
     Process p = Runtime.getRuntime().exec(CommandLine);
     is = p.getInputStream();
     InputStreamReader isr = new InputStreamReader(is);
     BufferedReader in = new BufferedReader(isr);
     while ((nextLine=in.readLine()) != null){
       System.out.println(nextLine);
     }
/*
     String nextLine = in.readLine();
     if(nextLine==null)
     System.out.println("this application does not write to stdout");
     else
     System.out.println(nextLine);
*/
     in.close();

     //   p.waitFor();        
    } 
     catch (Exception ex) {
     System.err.println("Error in starting the job :"+CommandLine);
     System.err.println(ex);
    }
   }

  public void submitRsh(String host, String user, String CommandLine) {
    CommandLine = "rsh -l "+user+" "+host+" "+CommandLine;
    submitLocally(CommandLine);
  }

  public void submitGlobus(String GramKeeper, String RSL, String user) {
    String CommandLine = "/npac/home/globus/globus_1.0/tools/sparc-sun-solaris2.5.1/bin/globusrun";
    CommandLine += " -r "+GramKeeper+" "+RSL;
    submitLocally(CommandLine);
  }    

  public void exportFile(String src, String dest, String remotehost,
                         String user){
    String cmdLine="rcp -p "+src+" "+user+"@"+remotehost+":"+dest;
    System.out.println(cmdLine);
    try {
        Process p =Runtime.getRuntime().exec(cmdLine);
        p.waitFor();
    }
    catch (Exception ex) {
     System.err.println("Error while rcp files :"+cmdLine);
     System.err.println(ex);
    }    
  }

  public void importFile(String src, String dest, String remotehost, 
                         String user){

    System.out.println(src);
    System.out.println(dest);
    System.out.println(remotehost);
    System.out.println(user); 
    String cmdLine="rcp -p "+user+"@"+remotehost+":"+src+" "+dest;
    System.out.println(cmdLine);
    try {
        Process p =Runtime.getRuntime().exec(cmdLine);
        p.waitFor();
    }
    catch (Exception ex) {
     System.err.println("Error while rcp files :"+cmdLine);
     System.err.println(ex);
    }    
  }

    public void setJobCompleted(String jobid){
      jobTable.put(jobid,Boolean.TRUE);
    }

    public boolean getJobCompleted(String jobid) {
       return ((Boolean)jobTable.get(jobid)).booleanValue();
    }    

    public void to_unix(String DOS, String UNIX) {
      String command = "/home/webflow/bin/to_unix.sh "+DOS+" "+UNIX;
      try {
             Process p = Runtime.getRuntime().exec(command);
             p.waitFor();     
      }
      catch (Exception e) {System.out.println(e+ "while to_unix");}
    }
}







